proc parse_in { {in} } {
   global state allowtcl

 #   set com [lindex $in 0]
   set com [string range $in 0 [expr [string first " " $in] -1] ]
   set rest [string range $in [expr [string first " " $in] +1] end ]
   switch $com  {DO_LS} {
      set olddir [pwd]; set dirs {}; set files {}
      set dir [lindex $rest 0]; set pattern [lindex $rest 1]
      if {[catch {cd $dir}] != 0} {
         pcsend "VALUE_LS $dir $pattern [list {non-existent dir} {}]"
         cd $olddir
         log "DO_LS $dir $pattern (Error: non-existent dir)\n"
         return
      }
      puts [pwd]
      foreach i [glob $pattern] {
         if [file exists $i] {
            if [file isdir $i] {
               lappend dirs $i
            } else {
               lappend files $i
            }
         }
      }
      pcsend "VALUE_LS $dir $pattern [list $dirs $files]"
      cd $olddir
      log "DO_LS $dir $pattern\n"
   }  {DO_TCL} {
      if {$allowtcl != 0} {
         set tcl $rest
         set cr [catch $tcl tclret]
 #         if {$cr == 0} {
 #            if {[info exists tclret] == 0} {set tclret ""}
 #         } else {
 #            set tclret ERROR
 #        }
         log "Tcl executed:\n$tcl\n"
         pcsend "DO_TCLRET $tclret"
      } else {
         log "Tcl command blocked (not allowed):\n$tcl\n"
      }
   }  {DO_SETVAR} {
      if {$allowtcl != 0} {
         set tclvar [lindex $rest 0]
         set tclval [lrange $rest 1 end]
         global $tclvar
         eval set $tclvar $tclval
 #         puts $tclvar
         log "Tcl set executed: set $tclvar $tclval\n"
      } else {
         log "Tcl set command blocked (not allowed): set $tclvar $tclval\n"
      }
   }  {DO_TCLRET} {
      if {$rest != ""} {log "Tcl Return value: $rest\n"}
      set state ready
   }  {VALUE_LS} {
      global crdir crpat crdirs crfiles
      set crdir   [lindex $rest 0]
      set crpat   [lindex $rest 1]
      set crdirs  [lindex $rest 2]
      set crfiles [lindex $rest 3]
      # puts "$rest\n$crdirs,$crfiles"
      .pc.f.ld del 0 end ; .pc.f.lf del 0 end
      foreach i $crdirs {.pc.f.ld insert end $i}
      foreach i $crfiles {.pc.f.lf insert end $i}
   }  {DO_RECFILE} {
      log "(requested: DO_RECFILE $rest)"
      eval receive_file $rest
      pcsend "READY_RECFILE "
      log "READY_RECFILE\n"
   }  {DO_SENDFILE} {
      log "(requested: DO_SENDFILE $rest)"
      eval send_file $rest
      pcsend "READY_SENDFILE "
      log "READY_SENDFILE\n"
   }  {DO_REQSENDFILE} {
      pcsend "DO_SENDFILE $rest"
      log "DO_SENDFILE $rest\n"
   }  {DO_ABORTFILE} {
      catch "close $filess; close $fileso; close $filed"
      log "Aborted file transfer.\n"
   }  {DO_CLOSECONTROL} {
      global rems
      disconnect $rems
      set rems -1
      log "Closed control connection.\n"
   } {sst:} {
      set state sst
      .pc.tcom insert end "REMOTE: sst:\n"
      .pc.tcom see end
   }  {default} {
      # bell
      if {$state == "ready" } {
        .pc.tcom insert end "REMOTE: $in\n"
        .pc.tcom see end
        set state ready
      } {
         pcotherstate $in
      }
      # after 200 bell
   }
 } 
proc pcotherstate { {in} } {
   global state sstarr
   switch $state {sst} {
      if {$in == "<endsst>"} {
         set state ready
         soundsst
         return
      }
      foreach {i j} $in {
         set sstarr($i) $j
      }
   } {default} {
     .pc.tcom insert end "PCOM: in undefined state $state\n"
     .pc.tcom see end
      set state ready
   }
} 
proc slidsendupdate { } {
   set t "makeadditivetable 1 "
   for {set i 1} {$i <= 8} {incr i} {
      lappend t $i
      lappend t [expr [.sl2.h$i.s get]/100.0]
   }
   pcsend $t
   pcsend "getsst 1000"
} 
proc soundsst { } {
   global sstarr mc ol; 
   puts "sst [array size sstarr] done"
   set ol {};
   foreach i [lsort -int [array names sstarr]] {
      lappend ol $sstarr($i)
   }
   array unset sstarr
   $mc del gr1 ;
   for {set i 0} {$i < [expr [llength $ol]-1]} {incr i} {
      $mc create line [expr $i+10] [expr 266-[lindex $ol $i]/256] [expr $i+1+10] [expr 266-[lindex $ol [expr $i+1]]/256] -tag gr1 -fill blue 
   }
} 

